﻿using System.Collections.Concurrent;
using System.Collections.Generic;
using BenchmarkDotNet.Attributes;

namespace ConsoleApp29
{
        public enum Enum4
    {
            Value0,
            Value1,
            Value2,
            Value3,
        }

    public static class EnumExtensions4
    {     
        private static readonly Dictionary<Enum4, string> s_cache = new Dictionary<Enum4, string>();
        private static readonly ConcurrentDictionary<Enum4, string> s_cacheConcurrent = new ConcurrentDictionary<Enum4, string>();
        private static readonly string[] s_cacheArray = GetEnumStrings();

        public static string ToStringCachedTyped(this Enum4 value)
        {
            if (s_cache.TryGetValue(value, out var result))
                return result;

            return s_cache[value] = value.ToString();
        }

        public static string ToStringCachedConcurrentTyped(this Enum4 value)
        {
            return s_cacheConcurrent.GetOrAdd(value, v => v.ToString());
        }

        private static string[] GetEnumStrings()
        {
            System.Collections.IList list = System.Enum.GetValues(typeof(Enum4));

            var result = new string[list.Count];
            for (int i = 0; i < list.Count; i++)
            {
                result[i] = list[i].ToString();
            }

            return result;
        }

        public static string ToStringCachedArray(this Enum4 myEnum)
        {
            return s_cacheArray[(int)myEnum];
        }

        public static string ToStringSwitch(this Enum4 myEnum)
        {
            return myEnum switch
            {
                            Enum4.Value0 => nameof(Enum4.Value0),
                            Enum4.Value1 => nameof(Enum4.Value1),
                            Enum4.Value2 => nameof(Enum4.Value2),
                            Enum4.Value3 => nameof(Enum4.Value3),
                            _ => throw new System.NotImplementedException(),
            };
        }
    }

        public partial class EnumToStringBenchmark
    {
        Enum4 _value4_0 = Enum4.Value0;

        [Benchmark]
        public string ToString4_0() => _value4_0.ToString();

        [Benchmark]
        public string Dictionary4_0() => _value4_0.ToStringCached();
    
        [Benchmark]
        public string TypedDictionary4_0() => _value4_0.ToStringCachedTyped();

        [Benchmark]
        public string ConcurrentDictionary4_0() => _value4_0.ToStringCachedConcurrent();
    
        [Benchmark]
        public string TypedConcurrentDictionary4_0() => _value4_0.ToStringCachedConcurrentTyped();

        [Benchmark]
        public string Array4_0() => _value4_0.ToStringCachedArray();

        [Benchmark]
        public string Switch4_0() => _value4_0.ToStringSwitch();
    }
        public partial class EnumToStringBenchmark
    {
        Enum4 _value4_2 = Enum4.Value2;

        [Benchmark]
        public string ToString4_2() => _value4_2.ToString();

        [Benchmark]
        public string Dictionary4_2() => _value4_2.ToStringCached();
    
        [Benchmark]
        public string TypedDictionary4_2() => _value4_2.ToStringCachedTyped();

        [Benchmark]
        public string ConcurrentDictionary4_2() => _value4_2.ToStringCachedConcurrent();
    
        [Benchmark]
        public string TypedConcurrentDictionary4_2() => _value4_2.ToStringCachedConcurrentTyped();

        [Benchmark]
        public string Array4_2() => _value4_2.ToStringCachedArray();

        [Benchmark]
        public string Switch4_2() => _value4_2.ToStringSwitch();
    }
        public partial class EnumToStringBenchmark
    {
        Enum4 _value4_3 = Enum4.Value3;

        [Benchmark]
        public string ToString4_3() => _value4_3.ToString();

        [Benchmark]
        public string Dictionary4_3() => _value4_3.ToStringCached();
    
        [Benchmark]
        public string TypedDictionary4_3() => _value4_3.ToStringCachedTyped();

        [Benchmark]
        public string ConcurrentDictionary4_3() => _value4_3.ToStringCachedConcurrent();
    
        [Benchmark]
        public string TypedConcurrentDictionary4_3() => _value4_3.ToStringCachedConcurrentTyped();

        [Benchmark]
        public string Array4_3() => _value4_3.ToStringCachedArray();

        [Benchmark]
        public string Switch4_3() => _value4_3.ToStringSwitch();
    }
            public enum Enum10
    {
            Value0,
            Value1,
            Value2,
            Value3,
            Value4,
            Value5,
            Value6,
            Value7,
            Value8,
            Value9,
        }

    public static class EnumExtensions10
    {     
        private static readonly Dictionary<Enum10, string> s_cache = new Dictionary<Enum10, string>();
        private static readonly ConcurrentDictionary<Enum10, string> s_cacheConcurrent = new ConcurrentDictionary<Enum10, string>();
        private static readonly string[] s_cacheArray = GetEnumStrings();

        public static string ToStringCachedTyped(this Enum10 value)
        {
            if (s_cache.TryGetValue(value, out var result))
                return result;

            return s_cache[value] = value.ToString();
        }

        public static string ToStringCachedConcurrentTyped(this Enum10 value)
        {
            return s_cacheConcurrent.GetOrAdd(value, v => v.ToString());
        }

        private static string[] GetEnumStrings()
        {
            System.Collections.IList list = System.Enum.GetValues(typeof(Enum10));

            var result = new string[list.Count];
            for (int i = 0; i < list.Count; i++)
            {
                result[i] = list[i].ToString();
            }

            return result;
        }

        public static string ToStringCachedArray(this Enum10 myEnum)
        {
            return s_cacheArray[(int)myEnum];
        }

        public static string ToStringSwitch(this Enum10 myEnum)
        {
            return myEnum switch
            {
                            Enum10.Value0 => nameof(Enum10.Value0),
                            Enum10.Value1 => nameof(Enum10.Value1),
                            Enum10.Value2 => nameof(Enum10.Value2),
                            Enum10.Value3 => nameof(Enum10.Value3),
                            Enum10.Value4 => nameof(Enum10.Value4),
                            Enum10.Value5 => nameof(Enum10.Value5),
                            Enum10.Value6 => nameof(Enum10.Value6),
                            Enum10.Value7 => nameof(Enum10.Value7),
                            Enum10.Value8 => nameof(Enum10.Value8),
                            Enum10.Value9 => nameof(Enum10.Value9),
                            _ => throw new System.NotImplementedException(),
            };
        }
    }

        public partial class EnumToStringBenchmark
    {
        Enum10 _value10_0 = Enum10.Value0;

        [Benchmark]
        public string ToString10_0() => _value10_0.ToString();

        [Benchmark]
        public string Dictionary10_0() => _value10_0.ToStringCached();
    
        [Benchmark]
        public string TypedDictionary10_0() => _value10_0.ToStringCachedTyped();

        [Benchmark]
        public string ConcurrentDictionary10_0() => _value10_0.ToStringCachedConcurrent();
    
        [Benchmark]
        public string TypedConcurrentDictionary10_0() => _value10_0.ToStringCachedConcurrentTyped();

        [Benchmark]
        public string Array10_0() => _value10_0.ToStringCachedArray();

        [Benchmark]
        public string Switch10_0() => _value10_0.ToStringSwitch();
    }
        public partial class EnumToStringBenchmark
    {
        Enum10 _value10_5 = Enum10.Value5;

        [Benchmark]
        public string ToString10_5() => _value10_5.ToString();

        [Benchmark]
        public string Dictionary10_5() => _value10_5.ToStringCached();
    
        [Benchmark]
        public string TypedDictionary10_5() => _value10_5.ToStringCachedTyped();

        [Benchmark]
        public string ConcurrentDictionary10_5() => _value10_5.ToStringCachedConcurrent();
    
        [Benchmark]
        public string TypedConcurrentDictionary10_5() => _value10_5.ToStringCachedConcurrentTyped();

        [Benchmark]
        public string Array10_5() => _value10_5.ToStringCachedArray();

        [Benchmark]
        public string Switch10_5() => _value10_5.ToStringSwitch();
    }
        public partial class EnumToStringBenchmark
    {
        Enum10 _value10_9 = Enum10.Value9;

        [Benchmark]
        public string ToString10_9() => _value10_9.ToString();

        [Benchmark]
        public string Dictionary10_9() => _value10_9.ToStringCached();
    
        [Benchmark]
        public string TypedDictionary10_9() => _value10_9.ToStringCachedTyped();

        [Benchmark]
        public string ConcurrentDictionary10_9() => _value10_9.ToStringCachedConcurrent();
    
        [Benchmark]
        public string TypedConcurrentDictionary10_9() => _value10_9.ToStringCachedConcurrentTyped();

        [Benchmark]
        public string Array10_9() => _value10_9.ToStringCachedArray();

        [Benchmark]
        public string Switch10_9() => _value10_9.ToStringSwitch();
    }
        }
